/*{ TemplateName::.h ************************************************
 
 Empty template for new header files.
 Copy and adapt to your needs.
 
}*/
//{ Defines/ TypeDefs ****************************************************


//} Defines
//{ Includes *************************************************************

 // Basic set of helper functions
#include "stm32_io.h"

#include <stdlib.h>

#define USE_STDPERIPH_DRIVER
#include "stm32f10x.h"
#include "core_cm3.h"        // StdPeripheralsLibrary/CMSIS/CM3/CoreSupport/
#include "stm32f10x_conf.h"

/*{ optional
// ADC
#include "stm32f10x_adc.h"
#include "stm32f10x_dma.h"

// Timers
#include "stm32f10x_tim.h"

#include "stm32f10x_it.h"
#include "system_stm32f10x.h"
}*/

#include "bits.h"

#include <string.h>
#include "FreeRTOS.h"
#include "task.h"

//} Includes
//{ STM32 Registers ******************************************************

typedef struct { // RCC_APB1ENR_t  APB1 peripheral clock enable register
  unsigned TIM2EN       : 1;
  unsigned TIM3EN       : 1;
  unsigned TIM4EN       : 1;
  unsigned reserved7    : 1;
  unsigned TIM6EN       : 1;
  unsigned TIM7EN       : 1;
  unsigned reserved6    : 5;
  unsigned WWDGEN       : 1;
  unsigned reserved5    : 2;
  unsigned SPI2EN       : 1;
  unsigned reserved4    : 2;
  unsigned USART2EN     : 1;
  unsigned USART3EN     : 1;
  unsigned reserved3    : 2;
  unsigned I2C1EN       : 1;
  unsigned I2C2EN       : 1;
  unsigned reserved2    : 4;
  unsigned BKPEN        : 1;
  unsigned PWREN        : 1;
  unsigned DACEN        : 1;
  unsigned CECEN        : 1;
  unsigned reserved1    : 1;
} __attribute__((__packed__)) RCC_APB1ENR_t;
typedef struct { // RCC_APB2ENR_t  APB2 peripheral clock enable register
  unsigned reserved5    : 1;
  unsigned USART1_EN    : 1;
  unsigned reserved4    : 1;
  unsigned SPI1_EN      : 1;
  unsigned TIM1_EN      : 1;
  unsigned reserved3    : 1;
  unsigned ADC1_EN      : 1;
  unsigned reserved2    : 2;
  unsigned IOPE_EN      : 1;
  unsigned IOPD_EN      : 1;
  unsigned IOPC_EN      : 1;
  unsigned IOPB_EN      : 1;
  unsigned IOPA_EN      : 1;
  unsigned reserved1    : 1;
  unsigned AFIO_EN      : 1;
} __attribute__((__packed__)) RCC_APB2ENR_t;
typedef struct { // TIMx_CR1_t     timer control register 1
  unsigned  CEN         : 1;
  unsigned  UDIS        : 1;
  unsigned  URS         : 1;
  unsigned  OPM         : 1;
  unsigned  DIR         : 1;
  unsigned  CMS         : 2;
  unsigned  ARPE        : 1;
  unsigned  CKD         : 2;
  unsigned  reserved1   : 6;
} __attribute__((__packed__)) TIMx_CR1_t ;
typedef struct { // TIMx_CR2_t     timer control register 2
  unsigned  CCPC        : 1;
  unsigned  reserved2   : 1;
  unsigned  CCUS        : 1;
  unsigned  CCDS        : 1;
  unsigned  MMS         : 2;
  unsigned  TI1S        : 1;
  unsigned  OIS1        : 1;
  unsigned  OIS1N       : 1;
  unsigned  OIS2        : 1;
  unsigned  OIS2N       : 1;
  unsigned  OIS3        : 1;
  unsigned  OIS3N       : 1;
  unsigned  OIS4        : 1;
  unsigned  reserved1   : 1;
} __attribute__((__packed__)) TIMx_CR2_t;
typedef struct { // TIMx_SMCR_t    timer slave mode control register
  unsigned  SMS         : 3;
  unsigned  TS          : 3;
  unsigned  MSM         : 1;
  unsigned  ETF         : 4;
  unsigned  ETPS        : 2;
  unsigned  EXE         : 1;
  unsigned  ETP         : 1;
} __attribute__((__packed__)) TIMx_SMCR_t;
typedef struct { // TIMx_DIER_t    timer DMA/interrupt enable register
  unsigned  UIE         : 1;
  unsigned  CC1IE       : 1;
  unsigned  CC2IE       : 1;
  unsigned  CC3IE       : 1;
  unsigned  CC4IE       : 1;
  unsigned  COMIE       : 1;
  unsigned  TIE         : 1;
  unsigned  BIE         : 1;
  unsigned  UDE         : 1;
  unsigned  CC1DE       : 1;
  unsigned  CC2DE       : 1;
  unsigned  CC3DE       : 1;
  unsigned  CC4DE       : 1;
  unsigned  COMDE       : 1;
  unsigned  TDE         : 1;
  unsigned  reserved1   : 1;
} __attribute__((__packed__)) TIMx_DIER_t;
typedef struct { // TIMx_SR_t      timer status register
  unsigned  UIF         : 1;
  unsigned  CC1IF       : 1;
  unsigned  CC2IF       : 1;
  unsigned  CC3IF       : 1;
  unsigned  CC4IF       : 1;
  unsigned  COMIF       : 1;
  unsigned  TIF         : 1;
  unsigned  BIF         : 1;
  unsigned  reserved2   : 1;
  unsigned  CC1OF       : 1;
  unsigned  CC2OF       : 1;
  unsigned  CC3OF       : 1;
  unsigned  CC4OF       : 1;
  unsigned  reserved1   : 3;
} __attribute__((__packed__)) TIMx_SR_t;
typedef struct { // TIMx_EGR_t     timer event generation register
  unsigned  UG          : 1;
  unsigned  CC1G        : 1;
  unsigned  CC2G        : 1;
  unsigned  CC3G        : 1;
  unsigned  CC4G        : 1;
  unsigned  COMG        : 1;
  unsigned  TG          : 1;
  unsigned  BG          : 1;
  unsigned  reserved1   : 8;
} __attribute__((__packed__)) TIMx_EGR_t;
typedef struct { // TIMx_CCMR1_t   timer capture/compare register 1
  unsigned  CC1S        : 2;
  unsigned  OC1FE       : 1;
  unsigned  OC1PE       : 1;
  unsigned  OC1M        : 3;
  unsigned  OC1CE       : 1;
  unsigned  CC2S        : 2;
  unsigned  OC2FE       : 1;
  unsigned  OC2PE       : 1;
  unsigned  OC2M        : 3;
  unsigned  OC2CE       : 1;
} __attribute__((__packed__)) TIMx_CCMR1_t;
typedef struct { // TIMx_CCMR2_t   timer capture/compare register 2
  unsigned  CC3S        : 2;
  unsigned  OC3FE       : 1;
  unsigned  OC3PE       : 1;
  unsigned  OC3M        : 3;
  unsigned  OC3CE       : 1;
  unsigned  CC4S        : 2;
  unsigned  OC4FE       : 1;
  unsigned  OC4PE       : 1;
  unsigned  OC4M        : 3;
  unsigned  OC4CE       : 1;
} __attribute__((__packed__)) TIMx_CCMR2_t;
typedef struct { // TIMx_CCER_t    timer DMA/interrupt enable register
  unsigned  CC1E      : 1;
  unsigned  CC1P      : 1;
  unsigned  CC1NE     : 1;
  unsigned  CC1NP     : 1;
  unsigned  CC2E      : 1;
  unsigned  CC2P      : 1;
  unsigned  CC2NE     : 1;
  unsigned  CC2NP     : 1;
  unsigned  CC3E      : 1;
  unsigned  CC3P      : 1;
  unsigned  CC3NE     : 1;
  unsigned  CC3NP     : 1;
  unsigned  CC4E      : 1;
  unsigned  CC4P      : 1;
  unsigned  reserved1 : 2;
} __attribute__((__packed__)) TIMx_CCER_t;
typedef struct { // TIMx_BDTR_t    timer break and dead-time register
  unsigned  DTG         : 8;
  unsigned  LOCK        : 2;
  unsigned  OSSI        : 1;
  unsigned  OSSR        : 1;
  unsigned  BKE         : 1;
  unsigned  BKP_        : 1;
  unsigned  AOE         : 1;
  unsigned  MOE         : 1;
} __attribute__((__packed__)) TIMx_BDTR_t;
typedef struct { // TIMx_DCR_t     timer DMA control register
  unsigned  DBA         : 5;
  unsigned  reserved2   : 3;
  unsigned  DBL         : 5;
  unsigned  reserved1   : 1;
} __attribute__((__packed__)) TIMx_DCR_t;
typedef struct { // TIMER_t        timer 1 registers
  TIMx_CR1_t    CR1;
  u16_t         RESERVED0;
  TIMx_CR2_t    CR2;
  u16_t         RESERVED1;
  TIMx_SMCR_t   SMCR;
  u16_t         RESERVED2;
  TIMx_DIER_t   DIER;
  u16_t         RESERVED3;
  TIMx_SR_t     SR;
  u16_t         RESERVED4;
  TIMx_EGR_t    EGR;
  u16_t         RESERVED5;
  TIMx_CCMR1_t  CCMR1;
  u16_t         RESERVED6;
  TIMx_CCMR2_t  CCMR2;
  u16_t         RESERVED7;
  TIMx_CCER_t   CCER;
  u16_t         RESERVED8;
  u16_t         CNT;
  u16_t         RESERVED9;
  u16_t         PSC;
  u16_t         RESERVED10;
  u16_t         ARR;
  u16_t         RESERVED11;
  u16_t         RCC_; // RCC already defined elsewhere
  u16_t         RESERVED12;
  u16_t         CCR1;
  u16_t         RESERVED13;
  u16_t         CCR2;
  u16_t         RESERVED14;
  u16_t         CCR3;
  u16_t         RESERVED15;
  u16_t         CCR4;
  u16_t         RESERVED16;
  TIMx_BDTR_t   BDTR;
  u16_t         RESERVED17;
  TIMx_DCR_t    DCR;
  u16_t         RESERVED18;
  u16_t         DMAR;
  u16_t         RESERVED19;
} TIMER_t;

//} STM32 Registers
