/*{ Template_FreeRTOS::.c ************************************************
 
  lcd_start() spawns thread taskBrightness()

  taskBrightness()
      Defines brightness of led as Ton / (Ton + Toff)
      spawns thread taskLEDs()
      while (1) {
        while (Ton < 100) { Ton++; Toff--; }
        while (Ton >   0) { Ton--; Toff++; }
      }

  taskLEDs()
      while (1) {
        switch on LED
        wait for Ton
        switch off LED
        wait for Toff
      }

}*/

#include "example_lcd_320x240.h"

//{ Function definitions *************************************************


void lcd_initPorts() {

    //{ init_LCD Start
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);

    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    GPIO_Init(GPIOE, &GPIO_InitStructure);
    GPIO_Init(GPIOF, &GPIO_InitStructure);
    GPIO_Init(GPIOG, &GPIO_InitStructure);

    /* Enable the FSMC Clock */
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC, ENABLE);

    LCD_Init();

    //} init_LCD Ende


}
void lcd_start() {
    lcd_initPorts();

    if (1) task_LCD(NULL);  // run as function (requires 512 bytes of stack size!)
    else                    // spawn new task with own stack
        xTaskCreate(task_LCD,                          // function to start as thread
                    (const signed char*) "LCD",        // thread name (just for debugging)
                    (size_t) 512,                      // stack size
                    (void *) NULL,                     // passed as argument to taskLEDs()
                    (unsigned portBASE_TYPE) 1,        // task priority (higher values mean more process time)
                    (xTaskHandle*) NULL                // can return a handle to created task
                    );
 }
void task_LCD(void *pvParameters) {
    LCD_SetBacklight(1);
    LCD_Clear(LCD_COLOR_YELLOW);

    LCD_DrawChar(1,1, '>', LCD_COLOR_YELLOW, LCD_COLOR_BLACK);
    LCD_ConSetColor(LCD_COLOR_YELLOW, LCD_COLOR_BLACK);
    LCD_ConSetPos(1,2);
    LCD_Printf("Hallo Welt");
    LCD_DrawChar(1,13, '<', LCD_COLOR_YELLOW, LCD_COLOR_BLACK);
    LCD_ConSetPos(3,1);
    LCD_ConSetColor(LCD_COLOR_GREEN, LCD_COLOR_RED);
    LCD_Printf("Seconds: ");

    int I = 0;
    while(1) {
        LCD_ConSetPos(3,10);
        LCD_Printf("%i", I++);
        mSleep(1000);
    }
}

//} Function definitions
