#ifndef EXAMPLE_THREADING
#define EXAMPLE_THREADING

/*{ TemplateName::.h ************************************************
 
 Empty template for new header files.
 Copy and adapt to your needs.
 
}*/
//{ Defines/ TypeDefs ****************************************************

#define LED_STAT1 GPIOC, 6
#define LED_STAT2 GPIOC, 7

//} Defines
//{ Includes *************************************************************

 // Basic set of helper functions
#include "stm32_io.h"
#include <stdlib.h>
#define USE_STDPERIPH_DRIVER
#include "stm32f10x.h"
#include "core_cm3.h"
#include "stm32f10x_conf.h"
#include "bits.h"
#include <string.h>
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "example_leds.h"

//} Includes
//{ Structures/ Enums ****************************************************

// continuation of stm32_io.h:ErrorCode_E
typedef enum {
    ec_et_InvalidQueueGiven
} ErrorCode_E;

/** data being sent to taskProducer()/ taskConsumer() */
typedef struct {
    xQueueHandle QueueHandle;
} et_ThreadInfo_t;

//} Structures/ Enums
//{ Global Variables *****************************************************



//} Global Variables
//{ Function prototypes **************************************************

// basic initialization (called from threading_start() )
void threading_init();

// run demo
void threading_start();

// produces tasks to do
void taskProducer(void *pvParameters);

// consumes + executes tasks to do
void taskConsumer(void *pvParameters);


//} Function prototypes

#endif //EXAMPLE_THREADING
