# (1)
# Where is our source code?
SourceDir=`pwd`

# (2) 
# obtain ToolChain_STM32 (if not already done)
cd
if [ ! -d Source ]; then
  mkdir Source
fi
cd Source
if [ ! -d ToolChain_STM32 ]; then
  wget -c http://hlb-labor.de/projekte/cortexm3/ToolChain_STM32_current.tar.bz
  tar xjf ToolChain_STM32_current.tar.bz
fi
cd ToolChain_STM32/ToolChain/
if [ ! -e AllInstallsOK ]; then
  echo "Installation incomplete: Starting toolchain installation.."
  ./installAll.sh
fi

# (2) 
# cd back to this source code directory
cd $SourceDir

# (3)
# recreate symbolic links to ToolChain_STM32
./createLinks.sh

# (4)
# update path variables to binary tools
source ./_/SourceMe.sh

# (5)
# compile source
./_/compile.sh

# (6)
# update project files
./_/updateProjectFiles.pl TemplateName.files >TemplateName.files.log

# (7)
# flash onto uC
if [ -e main.bin ]; then
  echo "Trying to flash binary onto microcontroller.."
  ./_/flash.sh main.bin || echo "Note: configure file _/interface.cfg according to your JTAG-programmer!"
fi

