#!/bin/bash
#
#  Install script for open source GCC G++ compiler for CortexM3 MicroControllers. 
#  Script written by Gregor Rebel 2010-2011.
#
# Reference: http://michaldemin.wordpress.com/2010/02/09/arm-toolchain-newlib-part1/
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on:
# Ubuntu 10.04 Netbook Edition x86
# KUbuntu 11.04 x86
# openSuSE 11.4 x86
# XUbuntu 11.10 x64

source scripts/installFuncs.sh

if [ "$USER" == "root" ]; then
  echo "$0: ERROR this script should not been run as user root!"
  exit 10
fi

INSTALLPATH="gcc_cortex_m3"
dir $INSTALLPATH
cd $INSTALLPATH

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW -----------------------------------------------

if [ ! -e OK.Install ]; then #{

echo "installing in $INSTALLPATH ..."

CleanUpBatch="cleanup.sh"

export TOOLPATH="`pwd`/bin/"
export ARMTARGET="arm-softfloat-elf"

get "http://ftp.gnu.org/gnu/binutils/"                   "binutils-2.20.1.tar.bz2"
get "ftp://ftp.gwdg.de/pub/misc/gcc/releases/gcc-4.4.3/" "gcc-4.4.3.tar.bz2"
get "ftp://sources.redhat.com/pub/newlib/"               "newlib-1.18.0.tar.gz"


if [ -e "$BinFolder/arm-none-eabi-gcc" ]; then
    cat <<END_OF_MAKEFILE >../extensions/makefile.$INSTALLPATH
#
#                               ToolChain_STM32
#
#                         Extension to central makefile
#
#                   makefile written by Gregor Rebel 2010-2011
#

EXTENSION_$INSTALLPATH = 1

END_OF_MAKEFILE

  echo "" >OK.Install
fi
fi #} [ ! -e OK.Install ]; then
if [   -e OK.Install ]; then #{
  addLine ../scripts/SourceMe.sh    "export PATH=\"\$PATH:$BinFolder/\""
  addLine ../scripts/createLinks.sh "rm 2>/dev/null $INSTALLPATH;           ln -sv \$Source/ToolChain_STM32/ToolChain/$INSTALLPATH/arm-2010q1/                                   $INSTALLPATH"
  echo "Installed successfully: $INSTALLPATH"
#}
else
  echo "failed to install $INSTALLPATH"
  exit 10
fi

#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

exit 0
