#!/bin/bash
#
#  Install script for ST Stdandard Peripherals Library
#  Script written by Gregor Rebel 2010-2011.
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on:
# Ubuntu 10.04 Netbook Edition x86
# KUbuntu 11.04 x86
# openSuSE 11.4 x86
# XUbuntu 11.10 x64

source scripts/installFuncs.sh

if [ "$USER" == "root" ]; then
  echo "$0: ERROR this script should not been run as user root!"
  exit 10
fi

INSTALLPATH="../Documentation"
dir $INSTALLPATH
cd $INSTALLPATH

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW --------------------------------------------

if [ -e OK.Install ]; then
  echo "Already installed: $INSTALLPATH"
  exit 0  
fi

echo "installing in $INSTALLPATH ..."
ERROR=""

# echo "D"; get https://silver.arm.com/download/           download.tm?pv=1073296  ARMv7-M_Architecture_Reference_Manual.pdf                                                                        || ERROR="1"
echo "D"; get http://www.eecs.umich.edu/~prabal/teaching/eecs373-f11/readings/                            ARMv7-M_ARM.pdf ARMv7-M_Architecture_Reference_Manual.pdf                                               || ERROR="1"
echo "D"; get http://home.comcast.net/~mcatudal/index_fichiers/                                           CrossDevHowto_STM32_Mandriva.pdf          HowTo_Using_Open_Source_Tools_for_STM32_under_Linux.pdf                                 || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/REFERENCE_MANUAL/   CD00240193.pdf STM32_Advanced_ARM-based_32bit_MCUs.pdf                                  || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/PROGRAMMING_MANUAL/ CD00228163.pdf Cortex-M3_programming_manual.pdf                                         || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/USER_MANUAL/        CD00004585.pdf STANDARD_PERIPHERAL_USERS_MANUAL_V1.1.pdf                                || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/USER_MANUAL/        CD00298482.pdf Advanced_developers_guide_for-STM32F103xx-STM32F100xx.pdf                || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/REFERENCE_MANUAL/   CD00246267.pdf STM32_RM0041_ReferenceManual_STM32F100xx.pdf                             || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/REFERENCE_MANUAL/   CD00171190.pdf STM32_RM0008_ReferenceManual_STM32F100xx.pdf                             || ERROR="1"
echo "D"; get http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/APPLICATION_NOTE/   CD00209826.pdf STM32_AN2824_STM32F10xxx_I2C_optimized_examples.pdf                      || ERROR="1"

if [ "$ERROR" == "" ]; then
  touch OK.Install
fi

if [ -e OK.Install ]; then
  echo "Installed successfully: $INSTALLPATH"
fi

#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

exit 0
