#!/bin/bash
#
#  Install script for CodeSourcery G++ compiler toolchain from CodeSourcery.
#  Script written by Gregor Rebel 2010-2011.
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on:
# Ubuntu 10.04 Netbook Edition x86
# KUbuntu 11.04 x86
# openSuSE 11.4 x86
# XUbuntu 11.10 x64

source scripts/installFuncs.sh

if [ "$USER" == "root" ]; then
  echo "$0: ERROR this script should not been run as user root!"
  exit 10
fi

INSTALLPATH="sourcery_g++"
dir $INSTALLPATH
cd $INSTALLPATH

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW -----------------------------------------------

if [ ! -e OK.Install ]; then #{

echo "installing in $INSTALLPATH ..."

Archive="arm-2010q1-188-arm-none-eabi-i686-pc-linux-gnu.tar.bz2"
if [ -e $Archive ]; then
  Error=""
  bzip2 -t $Archive || Error="1"
  if [ "$Error" != "" ]; then
    echo "Archive corrupt: $Archive"
    rm -v $Archive
  fi
fi
Folder="arm-2010q1"
Iterations=0
while [ "`bzip2 -t $Archive 2>&1`" != "" ]; do
  echo "trying to download $Archive ..."
  get http://www.codesourcery.com/sgpp/lite/arm/portal/package6493/public/arm-none-eabi/ $Archive
  Iterations=$(( $Iterations + 1 ))
  if [ $Iterations -gt 10 ]; then
    break
  fi
done


untgj Folder $Archive
BinFolder="`pwd`/$Folder/bin"
# add2CleanUp ../cleanup.sh "rm -Rf $INSTALLPATH/$Folder"

#get http://www.codesourcery.com/sgpp/lite/arm/portal/package6492/public/arm-none-eabi/ arm-2010q1-188-arm-none-eabi.src.tar.bz2
#untgj arm-2010q1-188-arm-none-eabi .src.tar.bz2

OldDir=`pwd`
cd ../../Documentation
dir $INSTALLPATH
cd $INSTALLPATH
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7609/ as.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7608/ binutils.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7616/ libc.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7612/ gcc.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7614/ gdb.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7615/ getting-started.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7610/ ld.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7617/ libm.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7613/ cpp.pdf
  get http://www.codesourcery.com/sgpp/lite/arm/portal/doc7611/ gprof.pdf
cd $OldDir

if [ -e "$BinFolder/arm-none-eabi-gcc" ]; then
    cat <<END_OF_MAKEFILE >../extensions/makefile.$INSTALLPATH
#
#                               ToolChain_STM32
#
#                         Extension to central makefile
#
#                   makefile written by Gregor Rebel 2010-2011
#

EXTENSION_$INSTALLPATH = 1

END_OF_MAKEFILE

  echo "" >OK.Install
#X  $BinFolder/arm-none-eabi-gcc --version | grep gcc
fi
fi #} [ ! -e OK.Install ]; then
if [   -e OK.Install ]; then #{
  addLine ../scripts/SourceMe.sh    "export PATH=\"\$PATH:$BinFolder/\""
  addLine ../scripts/createLinks.sh 'rm 2>/dev/null sourcery_g++;           ln -sv $Source/ToolChain_STM32/ToolChain/sourcery_g++/arm-2010q1/                                   sourcery_g++'
  echo "Installed successfully: $INSTALLPATH"
#}
else
  echo "failed to install $INSTALLPATH"
  exit 10
fi

#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

exit 0
