#!/bin/bash

Main="$1"

if [ "$Main" != "" ]; then
  if [ ! -e "mains/$Main" ]; then
    echo "$0 - ERROR: Cannot find main-file '$Main'!"
    echo "Available candidates: `ls -C mains/*.c`"
    exit 6
  fi
  rm 2>/dev/null main.c
  ln -s mains/$Main main.c
fi

if [ ! -e main.c ]; then
  echo "$0 - ERROR: No main.c selected!"
  echo "Available candidates: `ls -C mains/*.c`"
  exit 5
fi

Log="compile.log"

OK=""
echo "compiling..."
ls -l main.c
make clean >/dev/null 2>&1
make >$Log 2>&1 && OK="1"

if [ "$OK" == "1" ]; then
    echo "Compiled successfully:"
    ls -lh *.bin *.elf
    echo ""
else
    echo "ERROR occured during compilation!"
    less $Log
    exit 10
fi
echo ""

