#!/bin/bash

Version="$1"
if [ "$Version" == "" ]; then
  echo "$0 VERSION"
  exit 5
fi
Archive="ToolChain_STM32_${Version}.tar.bz"
if [ -e ../$Archive ]; then
  echo "$0 ERROR: ../$Archive already exists!"
  exit 6
fi


if [ ! -d ToolChain_STM32 ]; then
  git clone gitosis@hlb-labor.de:ToolChain_STM32
fi
cd ToolChain_STM32
echo $Version >Version
echo $Version >ToolChain/scripts/Version

mv History.readme History.readme_old
echo "$Version @`date`" >History.readme
git fetch
git log HEAD..origin >>History.readme
echo "---------------------------------------------------------"  >>History.readme
echo "" >>History.readme
cat History.readme_old >>History.readme
rm History.readme_old
cp History.readme ../../ToolChain_STM32.history

git pull
git commit -a -m "Package v${Version}"
git tag -f "Package_v${Version}"
git push
cd ..


rm -f ../ToolChain_STM32_current.tar.bz
mv ToolChain_STM32/.git .
tar cjf ../archive/ToolChain_STM32_${Version}.tar.bz ToolChain_STM32/
mv .git ToolChain_STM32/

ln -s archive/ToolChain_STM32_${Version}.tar.bz ../ToolChain_STM32_current.tar.bz
cp ToolChain_STM32/Template/template.* ../

