#!/bin/bash
#
# (c) Gregor Rebel 2010-2011

FILE="$1"

source _/interface.cfg

if [ "$FILE" == "" ]; then
  echo "$0 FLASHFILE"
  exit 10
fi

if [ ! -e "$FILE" ]; then
  echo "$0 - ERROR: Cannot read flash-file '$FILE'!"
  exit 11
fi

Script="flash.openocd"
cat >$Script <<END_OF_TEXT

# finish configuration stage + proceed to run stage
init

# hardware reset processor with halt
reset halt

# check target state
poll

# list all found falsh banks
flash banks

# identify the flash
flash probe 0

# unprotect flash for writing
#DEPRECATED flash protect_check 0 0

# erasing all flash
#DEPRECATED stm32x mass_erase 0
stm32f1x mass_erase 0

# write file to flash number 0
flash write_bank 0 $FILE 0

# hardware processor reset with run
reset run

#shutdown openocd daemon
shutdown
END_OF_TEXT

Script2="flash.sh"
cat >$Script2 <<END_OF_TEXT
#!/bin/bash

echo ">openocd -f interface/$Interface -f target/stm32f1x.cfg -f $Script"
openocd -f interface/$Interface -f target/stm32f1x.cfg -f $Script

END_OF_TEXT

bash ./$Script2

rm $Script $Script2


